unit MathPNO;

interface

type
  TScobPos = array[0..3, 1..2] of Integer;
  TTypeCode = (win, dos, koi, ukn);

  function GetIntFromStr(const AStr: string): Integer;
  //function ReplaceInString(const ss1, ss2: string; var s: string): Cardinal;
  function PosTS(ss, s:string; t: Cardinal): Cardinal;
  function PosFigured(const ALine: string; const APos: Integer; var APosB, APosE: Integer):string;
  function StrWinToDos(const Str: string; const C1C: Boolean): string;
  //function StrDosToWin(const Str: string): string;
  function StrDosToWinSpec(const Str: string; var a: TScobPos): string;
  function GetTypeCodeText(const Str: string): TTypeCode;
  function Str1CSpec(const Str: string; var a: TScobPos): string;

implementation

function GetIntFromStr(const AStr: string): Integer;
var AErr: Integer;
begin //     
  Val(AStr, Result, AErr);
end;

function PosTS(ss, s: string; t: Cardinal): Cardinal;
var  lss, ls: Cardinal;
begin //    ss   s    t
  Result:=0;
  if t=0 then t:=1;
  lss:=Length(ss);
  ls:=Length(s);
  if (ls=0) or (lss=0) or (lss>ls) or (t>ls) then Exit;
  s:=Copy(s, t, ls);
  Result:=Pos(ss, s);
  if Result<>0 then Result:=Result + t - 1;
end;

function PosFigured(const ALine: string; const APos: Integer; var APosB, APosE: Integer):string;
begin //     ,     ,  ''
  Result := '';
  APosB := APos - 1; APosE := APos;
  if (Length(ALine)<2) or (APos<=0) or (APos>Length(ALine)) then Exit;
  while ALine[APosB]<>'{' do
    if (APosB>1) and (ALine[APosB]<>'}') then APosB := APosB - 1 else Exit;
  while (ALine[APosE]<>'}') do
    if (APosE<Length(ALine)) and (ALine[APosE]<>'{') then APosE := APosE + 1 else Exit;
  //    ,    
  APosE := APosE + 1;
  Result := Copy(ALine, APosB, APosE-APosB);
end;

(*

function StrWinToDos(const Str: string): string;
var i: Integer;
begin
  Result := '';
  for i:=1 to Length(Str) do
    if (Ord(Str[i])>=192) and (Ord(Str[i])<=239) then
      Result := Result + Chr(Ord(Str[i])-64)
    else
    begin
      if (Ord(Str[i])>=240) and (Ord(Str[i])<=255) then
        Result := Result + Chr(Ord(Str[i])-16)
      else Result := Result + Str[i];
    end;
end;



function StrDosToWinSpec(const Str: string; var a: TScobPos): string;
var i: Integer;
begin
  Result := '';
  a[0,1] := 0;
  a[0,2] := 0;
  for i:=1 to Length(Str)+1 do
    if (Ord(Str[i])>=128) and (Ord(Str[i])<=175) then
      Result := Result + Chr(Ord(Str[i])+64)
    else
    begin
      if (Ord(Str[i])>=224) and (Ord(Str[i])<=239) then
        Result := Result + Chr(Ord(Str[i])+16)
      else
      begin
        Result := Result + Str[i];
        if Str[i]='{' then
        begin
          a[0,1] := a[0,1] + 1;
          a[a[0,1],1] := i;
        end;
        if Str[i]='}' then
        begin
          a[0,2] := a[0,2] + 1;
          a[a[0,2],2] := i;
        end;
      end;
    end;
end;

*)

function StrWinToDos(const Str: string; const C1C: Boolean): string;
var
  i: Integer;
  //tt: Boolean;
begin //    Win  Dos
  if C1C then //   1
  begin
    Result := Str;
    Exit;
  end;
  SetLength(Result, Length(Str));
  for i:=1 to Length(Str) do
    case Ord(Str[i]) of
      192..239: Result[i] := Chr(Ord(Str[i])-64);
      240..255: Result[i] := Chr(Ord(Str[i])-16);
      168:      Result[i] := Chr(240); // 
      184:      Result[i] := Chr(241); // 
      //150:      Result[i] := '-';
      //171, 187, 147, 148 : Result[i] := '"';
      //133:      begin tt := True; Result[i] := Chr(254); end; // ...
      //0..127:   Result[i] := ;
    else        Result[i] := Str[i];
    end;
    //if tt then ReplInStrNoCaseSens(Chr(254), '...', Result);
end;

(*

function StrDosToWin(const Str: string): string;
var i: Integer;
begin //   Dos  Win
  SetLength(Result, Length(Str));
  for i:=1 to Length(Str) do
    case Ord(Str[i]) of
      128..175: Result[i] := Chr(Ord(Str[i])+64);
      224..239: Result[i] := Chr(Ord(Str[i])+16);
      240:      Result[i] := Chr(168); // 
      241:      Result[i] := Chr(184); // 
      0..127:   Result[i] := Str[i];
    else        Result[i] := '+';
    end;
end;
*)

function StrDosToWinSpec(const Str: string; var a: TScobPos): string;
var i: Integer;
begin //  Str  Dos  Win     
  Result := '';
  a[0,1] := 0;
  a[0,2] := 0;
  for i:=1 to Length(Str)+1 do // - "+1"   ,  , ???
                               //        
    if (Ord(Str[i])>=128) and (Ord(Str[i])<=175) then
      Result := Result + Chr(Ord(Str[i])+64)
    else
    begin
      if (Ord(Str[i])>=224) and (Ord(Str[i])<=239) then
        Result := Result + Chr(Ord(Str[i])+16)
      else
      begin
        if Ord(Str[i])=240 then Result := Result + Chr(168)
        else if Ord(Str[i])=241 then Result := Result + Chr(184)
             else
             begin
               Result := Result + Str[i];
               if Str[i]='{' then
               begin
                 a[0,1] := a[0,1] + 1;
                 a[a[0,1],1] := i;
               end;
               if Str[i]='}' then
               begin
                 a[0,2] := a[0,2] + 1;
                 a[a[0,2],2] := i;
               end;
             end;
      end;
    end;
end;

function Str1CSpec(const Str: string; var a: TScobPos): string;
var i: Integer;
begin //      Str
  Result := Str + #0; //  ,  , ???
                      //        
  a[0,1] := 0;
  a[0,2] := 0;
  for i:=1 to Length(Str)+1 do
  begin
    if Str[i]='{' then
    begin
      a[0,1] := a[0,1] + 1;
      a[a[0,1],1] := i;
    end;
    if Str[i]='}' then
    begin
      a[0,2] := a[0,2] + 1;
      a[a[0,2],2] := i;
    end;
  end;
end;

function GetTypeCodeText(const Str: string): TTypeCode;
var
  i, uwin, udos, ukoi, swd: Integer;
  //sall: Integer;
  //prwin, prdos, prkoi: Integer;
begin //    win-dos-koi
  Result := ukn;
  uwin := 0; udos := 0; ukoi := 0; swd := 0;
  for i:=1 to Length(Str) do
    case Ord(Str[i]) of
      240..255: uwin := uwin + 1; // win
      160..175: udos := udos + 1; // dos
      224..239: swd := swd + 1;   //  win  dos
      192..223: ukoi := ukoi + 1; // koi
    end;
  if (uwin>udos) and (uwin+swd>ukoi) then Result := win;
  if (udos>uwin) and (udos+swd>ukoi) then Result := dos;
  if (ukoi>uwin+swd) and (ukoi>udos+swd) then Result := koi;
end;


end.
