unit untPrgOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, SynEdit, SynMemo, Grids, Menus;

type
  TRange = record
              B,  C: Integer;
           end;  
type
  TfrmPrgOpt = class(TForm)
    ckbxRunEditMSG: TCheckBox;
    ckbxCloseEditMSG: TCheckBox;
    grpbxPath: TGroupBox;
    lstbxScriptPaths: TListBox;
    ckbxRunLastFile: TCheckBox;
    grpbxPrepr: TGroupBox;
    edtPrepr: TEdit;
    spdbtnPrepr: TSpeedButton;
    opndlgPrepr: TOpenDialog;
    lblPrepr1: TLabel;
    edtHPath: TEdit;
    spdbtnHPath: TSpeedButton;
    lblPrepr2: TLabel;
    edtHEditor: TEdit;
    lblPrepr3: TLabel;
    spdbtnHEditor: TSpeedButton;
    opndlgHEditor: TOpenDialog;
    pmnScriptPaths: TPopupMenu;
    itmAddPath: TMenuItem;
    N1: TMenuItem;
    itmPasteStrings: TMenuItem;
    itmMovePath: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure spdbtnPreprClick(Sender: TObject);
    procedure spdbtnHPathClick(Sender: TObject);
    procedure spdbtnHEditorClick(Sender: TObject);
    procedure lstbxScriptPathsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure lstbxScriptPathsMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure itmAddPathClick(Sender: TObject);
    procedure itmPasteStringsClick(Sender: TObject);
    procedure lstbxScriptPathsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure itmMovePathClick(Sender: TObject);
    procedure pmnScriptPathsPopup(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MoveRange(AListBox: TListBox; ABeg, ACount, ADest: Integer);
  end;

procedure ShowPrgOpt;

var
  frmPrgOpt: TfrmPrgOpt;
  PathR: TRange;
  
implementation

uses untMain;

{$R *.DFM}

procedure ShowPrgOpt;
begin
  with TfrmPrgOpt.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmPrgOpt.FormShow(Sender: TObject);
var i: Integer;
begin //      
  ckbxRunLastFile.Checked := PrgOpt.RunLastFile;
  ckbxRunEditMSG.Checked := PrgOpt.RunEditMSG;
  ckbxCloseEditMSG.Checked := PrgOpt.CloseEditMSG;
  for i:=0 to Length(PrgOpt.ScrPath)-1 do
    lstbxScriptPaths.Items.Add(PrgOpt.ScrPath[i]);
  edtPrepr.Text := PrgOpt.PreprScriptPath;
  edtHPath.Text := PrgOpt.HPath;
  edtHEditor.Text := PrgOpt.HEditor;
  lstbxScriptPaths.SetFocus;
end;

procedure TfrmPrgOpt.FormClose(Sender: TObject; var Action: TCloseAction);
var i: Integer;
begin //       
  PrgOpt.RunLastFile := ckbxRunLastFile.Checked;
  PrgOpt.RunEditMSG := ckbxRunEditMSG.Checked;
  PrgOpt.CloseEditMSG := ckbxCloseEditMSG.Checked;
  SetLength(PrgOpt.ScrPath, lstbxScriptPaths.Items.Count);
  for i:=0 to lstbxScriptPaths.Items.Count-1 do
    PrgOpt.ScrPath[i] := lstbxScriptPaths.Items[i];
  PrgOpt.PreprScriptPath := edtPrepr.Text;
  PrgOpt.HPath := ExcludeTrailingBackslash(edtHPath.Text);
  PrgOpt.HEditor := edtHEditor.Text;
end;

procedure TfrmPrgOpt.spdbtnPreprClick(Sender: TObject);
begin //   ,  
  if edtPrepr.Text<>'' then
    opndlgPrepr.InitialDir := edtPrepr.Text;
  if opndlgPrepr.Execute then
  begin
    edtPrepr.Text := opndlgPrepr.FileName;
    opndlgPrepr.FileName := '';
  end;
end;

procedure TfrmPrgOpt.spdbtnHPathClick(Sender: TObject);
var Dir: string;
begin //      
  if SelectDirectory('      *.h:', '', Dir) then
    edtHPath.Text := Dir;
end;

procedure TfrmPrgOpt.spdbtnHEditorClick(Sender: TObject);
begin
  with opndlgHEditor do
    begin
    if edtHEditor.Text<>'' then
      InitialDir := edtHEditor.Text;
    if Execute then
    begin
      edtHEditor.Text := FileName;
      FileName := '';
    end;
  end;
end;

procedure TfrmPrgOpt.lstbxScriptPathsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //     
  with lstbxScriptPaths do
  begin
    pmnScriptPaths.AutoPopup := not(MultiSelect);
    if (Button=mbRight) and MultiSelect then //  
    begin //     
      Cursor := crDefault;
      MultiSelect := False;
      SetFocus;
    end;
  end;
end;

procedure TfrmPrgOpt.MoveRange(AListBox: TListBox; ABeg, ACount, ADest: Integer);
var i: Integer;
begin //      TListBox
  if ADest<ABeg then
    for i:=0 to ACount-1 do
      AListBox.Items.Move(ABeg+i, ADest+i);
  if ADest>ABeg+ACount-1 then
    for i:=0 to ACount-1 do
      AListBox.Items.Move(ABeg, ADest);
end;

procedure TfrmPrgOpt.lstbxScriptPathsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //    
  with lstbxScriptPaths do
  begin
    if (Button=mbLeft) and (Cursor=crDrag) then //  
    begin //     
      MoveRange(lstbxScriptPaths, PathR.B, PathR.C, ItemIndex); //   
      Cursor := crDefault;
      MultiSelect := False;
    end;

    if (Button=mbLeft) and (Cursor=crHandPoint) then //  
    begin //      
      PathR.B := 0;
      while PathR.B<Items.Count do
      begin
        if Selected[PathR.B] then Break;
        Inc(PathR.B);
      end;
      PathR.C := SelCount;
      Cursor := crDrag;
      //stsbrMain.Panels[0].Text := ' ,       ';
    end;
  end;
end;

procedure TfrmPrgOpt.itmAddPathClick(Sender: TObject);
var
  Dir: string;
  i: Integer;
begin //  
  if SelectDirectory('    :', '', Dir) then
    with lstbxScriptPaths do
    begin
      for i:=0 to Items.Count-1 do //   ,    
        if AnsiLowerCase(Items[i])=AnsiLowerCase(IncludeTrailingBackslash(Dir)) then Exit;
      Items.Add(IncludeTrailingBackslash(Dir));
    end;
end;

procedure TfrmPrgOpt.itmPasteStringsClick(Sender: TObject);
var i, j, ACount: Integer;
begin //     
  with frmMain.rcdtTemp do
  begin
    Text := '';
    PasteFromClipboard;
    if Text='' then Exit;
    ACount := lstbxScriptPaths.Items.Count;
    for i:=0 to Lines.Count-1 do
    begin
      if (Lines[i]='') or not(DirectoryExists(Lines[i])) then Continue;
      for j:=0 to ACount-1 do
        if Lines[i]=lstbxScriptPaths.Items[j] then Break;
      if (j>ACount-1) then lstbxScriptPaths.Items.Add(Lines[i]);
    end;
  end;
end;

procedure TfrmPrgOpt.lstbxScriptPathsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: Integer;
begin //  
  with lstbxScriptPaths do
  begin
    if (key=VK_ESCAPE) and MultiSelect then // * Esc *
    begin //     
      Cursor := crDefault;
      MultiSelect := False;
      SetFocus;
      Key:=0;
    end;
    if MultiSelect then
    begin
      Key := 0;
      Exit;
    end
    else
    //if not(MultiSelect) then
    begin
      if (Key=VK_UP) and (ssCtrl in Shift) then //   + Ctrl
      begin //       
        if ItemIndex>0 then Items.Exchange(ItemIndex, ItemIndex-1);
        Key := 0;
      end;
      if (Key=VK_DOWN) and (ssCtrl in Shift) then //   + Ctrl
      begin //       
        if (ItemIndex>-1) and (ItemIndex<Items.Count-1) then Items.Exchange(ItemIndex, ItemIndex+1);
        Key := 0;
      end;
      if (Key=VK_DELETE) and (ItemIndex>=0) then // Delete
      begin
        i := ItemIndex;
        Items.Delete(i); // 
        if Items.Count>=0 then
        begin
          if i>0 then ItemIndex:=i
          else ItemIndex:=0;
        end
      end;
    end;
  end;
end;

procedure TfrmPrgOpt.itmMovePathClick(Sender: TObject);
begin //   
  with lstbxScriptPaths do
    if Items.Count>1 then
    begin
      LockWindowUpdate(frmPrgOpt.Handle);
      MultiSelect := True;
      Cursor := crHandPoint;
      LockWindowUpdate(0);
    end;
end;

procedure TfrmPrgOpt.pmnScriptPathsPopup(Sender: TObject);
begin //  
  itmMovePath.Enabled := lstbxScriptPaths.Items.Count>1;
end;

end.
