unit untScriptShow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SynEdit, SynMemo, Comctrls, StdCtrls, Menus, Clipbrd, ToolWin, ExtCtrls,
  ImgList;

type
  TfrmScriptShow = class(TForm)
    mScriptShow: TSynMemo;
    mnuPopSH: TPopupMenu;
    itmCut: TMenuItem;
    itmCopy: TMenuItem;
    itmPaste: TMenuItem;
    itmDelete: TMenuItem;
    itmDev1: TMenuItem;
    itmUndo: TMenuItem;
    tlbrScriptShow: TToolBar;
    tlbtnCompare: TToolButton;
    tlbtnRestoreOld: TToolButton;
    tlbtnDev1: TToolButton;
    mLocal: TSynMemo;
    spltrLoRe: TSplitter;
    mReceived: TSynMemo;
    stsbrCompare: TStatusBar;
    tlbrCompare: TToolBar;
    tlbtnCompareEnd: TToolButton;
    imglstCompare: TImageList;
    mnuPopCopyL: TPopupMenu;
    itmCopyOnlyL: TMenuItem;
    mnuPopCopyR: TPopupMenu;
    itmCopyOnlyR: TMenuItem;
    tlbtnDev2: TToolButton;
    tlbtnDown: TToolButton;
    tlbtnUp: TToolButton;
    mScriptView: TSynMemo;
    spltrSV: TSplitter;
    tlbtnDev3: TToolButton;
    tlbtnView: TToolButton;
    tlbtnViewReRead: TToolButton;
    mnuPopV: TPopupMenu;
    itmCopyV: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure itmCutClick(Sender: TObject);
    procedure itmCopyClick(Sender: TObject);
    procedure itmPasteClick(Sender: TObject);
    procedure itmDeleteClick(Sender: TObject);
    procedure itmUndoClick(Sender: TObject);
    procedure mnuPopSHPopup(Sender: TObject);
    procedure mScriptShowKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tlbtnCompareClick(Sender: TObject);
    procedure tlbtnRestoreOldClick(Sender: TObject);
    procedure mLocalStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure mReceivedStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure mLocalSpecialLineColors(Sender: TObject; Line: Integer;
      var Special: Boolean; var FG, BG: TColor);
    procedure mReceivedSpecialLineColors(Sender: TObject; Line: Integer;
      var Special: Boolean; var FG, BG: TColor);
    procedure tlbtnCompareEndClick(Sender: TObject);
    procedure tlbrCompareResize(Sender: TObject);
    procedure spltrLoReMoved(Sender: TObject);
    procedure itmCopyOnlyLClick(Sender: TObject);
    procedure mnuPopCopyLPopup(Sender: TObject);
    procedure itmCopyOnlyRClick(Sender: TObject);
    procedure mnuPopCopyRPopup(Sender: TObject);
    procedure mLocalDblClick(Sender: TObject);
    procedure tlbtnDownClick(Sender: TObject);
    procedure tlbtnUpClick(Sender: TObject);
    procedure mLocalMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mReceivedMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mReceivedKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mScriptShowClick(Sender: TObject);
    procedure mScriptShowKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tmrScriptShowActivateTimer(Sender: TObject);
    procedure tlbtnViewClick(Sender: TObject);
    procedure tlbtnViewReReadClick(Sender: TObject);
    procedure itmCopyVClick(Sender: TObject);
    procedure mnuPopVPopup(Sender: TObject);
  private { Private declarations }
    procedure CreateScriptForShow;
    procedure SetCompareScripts;
    procedure CompareTwoTexts(var OneSource, TwoSource, OneDest, TwoDest: TSynMemo);
    procedure CopyNLines(var ASource, ADest: TSynMemo; const BegLine, ACount: Integer{; const Flag: Boolean});
    procedure AddNCR(var AMemo: TSynMemo; ACount: Integer{; const Flag: Boolean});
    procedure AppActivate(Sender: TObject);
  public
    { Public declarations }
  end;

procedure ScriptShow(LineNom: Integer);

const CNameScriptShow = ' ';

var
  frmScriptShow: TfrmScriptShow;
  FlagScriptShow: Boolean; //    
  ANameCompare: string; //     
  LineCompareL, LineCompareR: array of Byte; //   
  SS: array of Integer; //     
  ExeCompareL, ExeCompareR: Boolean; //  "   "
  ScrollMessage: TWMVScroll;
  FlagScroll: Boolean = False; //   True   
  OldColor: Integer; //   
  OldCaretPosY: Integer; //   
  FlagStart: Boolean;
  AbsLineNom: Integer;

implementation

uses untMain, MathPNO;

{$R *.DFM}

procedure ScriptShow(LineNom: Integer);
begin
  AbsLineNom := LineNom;
  with TfrmScriptShow.Create(Application) do
    try
      FlagScriptShow := True;
      ShowModal;
    finally
      Free;
      FlagScriptShow := False;
    end;
end;

procedure TfrmScriptShow.FormCreate(Sender: TObject);
begin //    
  Application.OnActivate := AppActivate;
  Left := StatScrShow.Left;
  Top := StatScrShow.Top;
  Width := StatScrShow.Width;
  Height := StatScrShow.Height;
  if StatScrShow.Max then WindowState := wsMaximized;
  Caption := CNameScriptShow + ' - [' + ExtractFileName(AFileName) + ']';
  frmMain.scpFunc.Editor := mScriptShow;
end;

procedure TfrmScriptShow.AppActivate(Sender: TObject);
begin //   ,    
  if FlagScriptShow then
  begin
    //frmScriptShow.SetFocus; //  
    //tlbrScriptShow.SetFocus;
    stsbrCompare.SetFocus;
  end;
end;

procedure TfrmScriptShow.FormClose(Sender: TObject; var Action: TCloseAction);
begin //      
  if WindowState = wsMaximized then StatScrShow.Max := True
  else
  begin
    StatScrShow.Max := False;
    StatScrShow.Left := Left;
    StatScrShow.Top := Top;
    StatScrShow.Width := Width;
    StatScrShow.Height := Height;
  end;

  if mScriptShow.Modified then //    
  begin
    //    
    BringWindowToTop(frmMain.Handle); //        
    try
      with frmMain do
      begin
        //CreateNewScript(False);
        //ActiveMemo.SetFocus; //   
        rcdtTemp.Text := mScriptShow.Text;
        LoadedScript;
        AModif := True;
        tlbtnSave.Enabled := AModif;
      end;
    except
      ShowMessage(' :   "TfrmScriptShow.FormClose" '+
                  '     .');
    end;
  end;
  with frmMain do
  begin
    SetActiveMemo(AbsPosToScriptPos(mScriptShow.CaretY));
    CloseOldTS(GetActiveIndex); //  
  end;
  frmMain.rcdtTemp.Text := '';
  frmMain.rcdtTemp.Tag := 0; //   
end;

procedure TfrmScriptShow.FormShow(Sender: TObject);
begin //     
  //tmrScriptShowActivate.Enabled := True;
  if frmMain.rcdtTemp.Tag=0 then frmMain.rcdtTemp.Tag:=3; //   
  CreateScriptForShow; //  
  ExeCompareL := False; //   
  ExeCompareR := False; //   
  if frmMain.rcdtTemp.Tag<>3 then SetCompareScripts; //  
  ShowScrollBar(mReceived.Handle, SB_VERT, False); //     mReceived
  //stsbrCompare.Panels[0].Text := IntToStr(AbsLineNom);
  mScriptShow.CaretY := AbsLineNom; //    
  mScriptShow.TopLine := mScriptShow.CaretY; //     
  //stsbrCompare.Panels[0].Text := IntToStr(mScriptShow.DisplayY);
end;

procedure TfrmScriptShow.CreateScriptForShow;
var
  i: Word;
  Nakop: string;
  //ATempSheet: TTabSheet;
begin //     
  tlbrScriptShow.Enabled := False; //  
  mScriptShow.Enabled := False; //  
  mScriptShow.ClearAll;
  with frmMain do
    for i:=0 to pnlMain.ControlCount-1 do
    begin
      with IndexMemo(i) do
      begin
        if (Lines[Lines.Count-1]<>'') and (i<>pnlMain.ControlCount-1) then
          Nakop := Nakop + Lines.Text + CR
        else Nakop := Nakop + Lines.Text;
        stsbrMain.Panels[0].Text := ' : ' + IntToStr(i);
        Application.ProcessMessages;
      end;
    end;
  frmMain.stsbrMain.Panels[0].Text := '';
  mScriptShow.Text := Nakop;

  mScriptView.Lines := mScriptShow.Lines;

  tlbrScriptShow.Enabled := True; //  
  mScriptShow.Enabled := True; //  
end;
(*
procedure TfrmScriptShow.ReturnScript;
var
  TekPos, ProcPos, EndPos, BECount: Integer;
  i: Integer;
  FlagOpREM, FlagClREM, FlagSDiv, FlagSStar: Boolean;
  FlagOpREM1, FlagClREM1, FlagSDiv1, FlagSStar1: Boolean;
  FlagPrep: Boolean;
  Tmp, Tmp1: String;
  ProcName: String;
  NewMemo: TSynMemo;
  Flag09: Boolean;
  FlagTz: Boolean; //  ";"     "variable"   
  FlagProc : Boolean; //      "variable"  "procedure"   
  FlagInProc: Boolean; //  ,     (    "#")
begin //    

  with frmMain do
  begin
    mInitial.ClearAll; //.Clear;
    Tmp1 := mScriptShow.Text;
    if Tmp1='' then Exit; //    
    //       #09
    Flag09 := False;
    i := 1;
    repeat
      if (Tmp1[i]=#09) or Flag09 then
      begin
        if Flag09 then
        begin
          if Tmp1[i]=#09 then Tmp:=Tmp+#32#32 else Tmp:=Tmp+Tmp1[i];
        end
        else
        begin
          Flag09 := True;
          Tmp := Copy(Tmp1, 1, i-1);
        end;
      end;
      Inc(i);
    until i>Length(Tmp1);
    if not(Flag09) then Tmp := Tmp1;
    //    #09
    //   
    FlagOpREM := False;
    FlagClREM := False;
    FlagSDiv := False;
    FlagSStar := False;
    FlagTz := False;
    FlagProc := False; // ???
    ProcPos := 0;
    TekPos := 1;
    repeat
      case Tmp[TekPos] of
        #13, #10: begin
                    FlagSDiv := False;
                    FlagSStar := False;
                    FlagOpREM := False;
                  end;
        '/': begin
               FlagOpRem := FlagOpRem or (FlagSDiv and not(FlagClRem));
               FlagClRem := FlagClRem and not(FlagSStar) and not(FlagOpRem);
               FlagSStar := False;
               FlagSDiv := True;
             end;
        '*': begin
               FlagClRem := FlagClRem or FlagSDiv and not(FlagOpRem);
               FlagSDiv := False;
               FlagSStar := True;
             end;
        'p', 'P': if not(FlagClREM or FlagOpREM) then
                    if AnsiLowerCase(Copy(Tmp, TekPos, 9))='procedure' then
                    begin
                      ProcPos := TekPos;
                      TekPos := TekPos + 8;
                      FlagTz := False; //   variable     
                      FlagProc := True; // ???
                    end;
        ';': FlagTz := True; //   variable     
        'b','B':  if not(FlagClREM or FlagOpREM) then
                    if (AnsiLowerCase(Copy(Tmp, TekPos, 5))='begin')
                       and IsDelimiter( ' /'+CR, AnsiLowerCase(Tmp[TekPos+5]), 1) //    "begin"   
                       and FlagProc then //    "variable"  "procedure"   
                    begin
                      if (PosTf('#', Copy(Tmp, ProcPos+9, TekPos-ProcPos), 0)=-1) and not(FlagTz) then Break;
                      TekPos := TekPos + 4;
                    end;
      else begin
             FlagSDiv := False;
             FlagSStar := False;
           end;
      end;
      Inc(TekPos);
      Application.ProcessMessages;
    until TekPos>Length(Tmp);
    if TekPos>Length(Tmp) then
    begin
      mInitial.Text := Copy(Tmp, 1, Length(Tmp)-1); // rcdtTemp.text
      TekPos := Length(Tmp);
    end
    else
    begin
      mInitial.Text := Copy(Tmp, 1, ProcPos-1); // rcdtTemp.text
      TekPos := ProcPos; // *** ??? ***     "p"   ,    - .
    end;
    //   
    FlagInProc := False;
    FlagOpREM := False;
    FlagClREM := False;
    FlagSDiv := False;
    FlagSStar := False;
    //EndPos := TekPos;
    EndPos := TekPos - 1 ; // *** ??? ***     "p"   ,    - .
    BECount := 0;
    FlagPrep := False;
    repeat
      case Tmp[TekPos] of
        //'#': FlagPrep := True; //      #define  
        '#': if not(FlagClREM or FlagOpREM) and not(FlagInProc) then FlagPrep := True; //      #define  
        #13, #10: begin
                    FlagSDiv := False;
                    FlagSStar := False;
                    FlagOpREM := False;
                  end;
        '/': begin
               FlagOpRem := FlagOpRem or (FlagSDiv and not(FlagClRem));
               FlagClRem := FlagClRem and not(FlagSStar) and not(FlagOpRem);
               FlagSStar := False;
               FlagSDiv := True;
             end;
        '*': begin
               FlagClRem := FlagClRem or FlagSDiv and not(FlagOpRem);
               FlagSDiv := False;
               FlagSStar := True;
             end;
        'p', 'P': if not(FlagClREM or FlagOpREM) then
                    if IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos+9]), 1) and
                       IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos-1]), 1) and
                       (AnsiLowerCase(Copy(Tmp, TekPos, 9))='procedure') then
                    begin
                      ProcPos := TekPos;
                      TekPos := TekPos + 8;
                      FlagPrep := False;
                      FlagInProc := True; //   
                    end;
        'b','B':  if not(FlagClREM or FlagOpREM or FlagPrep) then
                    if IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos+5]), 1) and
                       IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos-1]), 1) and
                       (AnsiLowerCase(Copy(Tmp, TekPos, 5))='begin') then    
                    begin
                      if BECount=0 then //  "begin"  "procedure"
                      begin
                        ProcName := Copy(Tmp, ProcPos+9, TekPos-ProcPos-10);
                        FlagOpRem1 := False;
                        FlagClRem1 := False;
                        FlagSDiv1 := False;
                        FlagSStar1 := False;
                        i := 1;
                        repeat
                          case ProcName[i] of
                            #13, #10: begin
                                        FlagSDiv1 := False;
                                        FlagSStar1 := False;
                                        FlagOpREM1 := False;
                                      end;
                            '/': begin
                                   FlagOpRem1 := FlagOpRem1 or (FlagSDiv1 and not(FlagClRem1));
                                   FlagClRem1 := FlagClRem1 and not(FlagSStar1) and not(FlagOpRem1);
                                   FlagSStar1 := False;
                                   FlagSDiv1 := True;
                                   ProcName[i] := ' ';
                                 end;
                            '*': begin
                                   FlagClRem1 := FlagClRem1 or FlagSDiv1 and not(FlagOpRem1);
                                   FlagSDiv1 := False;
                                   FlagSStar1 := True;
                                   ProcName[i] := ' ';
                                 end;
                          else begin
                                 if FlagOpRem1 or FlagClRem1 then ProcName[i] := ' '
                                 else if ProcName[i]='(' then //   
                                      begin
                                        ProcName := Copy(ProcName, 1, i-1);
                                        Break;
                                      end;
                                 FlagSDiv1 := False;
                                 FlagSStar1 := False;
                               end;
                          end;
                          Inc(i);
                        until i>Length(ProcName);
                        ProcName := Trim(ProcName); //   
                      end;
                      Inc(BECount);
                      TekPos := TekPos + 4;
                    end;
        'e','E':  if not(FlagClREM or FlagOpREM or FlagPrep) then
                    if IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos+3]), 1) and
                       IsDelimiter( '/ '+CR, AnsiLowerCase(Tmp[TekPos-1]), 1) and
                       (AnsiLowerCase(Copy(Tmp, TekPos, 3))='end') then
                    begin
                      Dec(BECount); //   ..  end
                      if BECount=0 then //   begin   end    
                      begin
                        //       NewMemo
                        NewMemo := AddNewPageOfPgCntrl(ProcName, True); //   
                        NewMemo.Text := DelCRLeft(Copy(Tmp, EndPos+1, TekPos+2-EndPos));
                        stsbrMain.Panels[0].Text := ' : ' + IntToStr(pgcntrlMain.PageCount);
                        EndPos := TekPos + 2;
                        BECount := 0;
                        FlagInProc := False; //   
                      end;
                      TekPos := TekPos + 2;
                    end;
      else begin
             FlagSDiv := False;
             FlagSStar := False;
           end;
      end;
      Inc(TekPos);
      Application.ProcessMessages;
    until TekPos>Length(Tmp);
    if pgcntrlMain.ActivePage<>pgcntrlMain.Pages[0] then //         
      with pgcntrlMain.ActivePage.Controls[0] as TSynMemo do
        Text := TrimRight(Text) + Copy(Tmp, EndPos+1, Length(Tmp)-EndPos-1)
    else with pgcntrlMain.Pages[0].Controls[0] as TSynMemo do
           Text := Text + Copy(Tmp, EndPos+1, Length(Tmp)-EndPos-1);
    pgcntrlMain.ActivePage := pgcntrlMain.Pages[0]; //    
    stsbrMain.Panels[0].Text := '';
    //mScriptShow.ClearAll;
    FillNavigateList; //       
  end;
  
end;

procedure TfrmScriptShow.ClearScriptForCloseShow;//(Sender: TObject);
var i: Word;
begin //  
  with frmMain do
  begin
    //SetFocusTekMemo;
    //ActiveMemo.SetFocus;
    NormCurAndCol; //      
    //with pnlMain do
    //begin
      //Visible := False;
      //for i:=PageCount-1 downto 1 do Pages[i].Free; //   
      frmMain.CreateNewScript(True);
      //Visible := True;
    //end;
    //mInitial.ClearAll; //.Clear
    AModif := True;
    tlbtnSave.Enabled := AModif;
    //PrUIN := 0;
    //CloseOldTS(0); //  

    ActiveMemo.SetFocus; //   
    //FillNavigateList;
  end;
end;
*)
(*
procedure TfrmScriptShow.Button1Click(Sender: TObject);
begin
  //ShowWindow(frmScriptShow.Handle, SW_HIDE);
  //frmScriptShow.Visible := False;
  //SendMessage(frmScriptShow.Handle, WM_SHOWWINDOW, 0, 0);
  //SendMessage(frmScriptShow.Handle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
  //frmScriptShow.Visible := True;
  //if frmScriptShow.Visible then ShowMessage('True');
  //frmScriptShow.Visible := False;
  //SetForegroundWindow(frmScriptShow.Handle);
  {
  SendMessage(frmScriptShow.Handle, WM_SHOWWINDOW, 0, 0);
  SendMessage(frmScriptShow.Handle, WM_WINDOWPOSCHANGING, 0, 0);
  SendMessage(frmScriptShow.Handle, WM_WINDOWPOSCHANGED, 0, 0);
  SendMessage(frmScriptShow.Handle, WM_GETTEXTLENGTH, 0, 0);
  SendMessage(frmScriptShow.Handle, WM_GETICON, 0, 0);
  SendMessage(frmScriptShow.Handle, WM_GETICON, 0, 0);
  }
  //SendMessage(, WM_SHOWWINDOW, 0, 1);
  //BringWindowToTop(frmScriptShow.Handle);
  //SendMessage(frmScriptShow.Handle, WM_SHOWWINDOW, 0, 2);
  //SendMessage(frmScriptShow.Handle, WM_SHOWWINDOW, 0, 3);
  //SendMessage(frmScriptShow.Handle, WM_SHOWWINDOW, 0, 4);
  //SetForegroundWindow(frmMain.Handle);
  BringWindowToTop(frmMain.Handle);
end;
*)

procedure TfrmScriptShow.itmCutClick(Sender: TObject);
begin // 
  mScriptShow.CutToClipboard;
end;

procedure TfrmScriptShow.itmCopyClick(Sender: TObject);
begin // 
  mScriptShow.CopyToClipboard;
end;

procedure TfrmScriptShow.itmPasteClick(Sender: TObject);
begin // 
  mScriptShow.PasteFromClipboard;
end;

procedure TfrmScriptShow.itmDeleteClick(Sender: TObject);
begin // 
  mScriptShow.ClearSelection;
end;

procedure TfrmScriptShow.itmUndoClick(Sender: TObject);
begin //  Undo
  mScriptShow.Undo;
end;

procedure TfrmScriptShow.mnuPopSHPopup(Sender: TObject);
begin //     Cut-Copy-Past
  with mScriptShow do
  begin
    itmCut.Enabled := SelText<>''; // 
    itmCut.Visible := not(ReadOnly);
    itmCopy.Enabled := SelText<>''; // 
    itmPaste.Enabled := Clipboard.HasFormat(CF_TEXT); // 
    itmPaste.Visible := not(ReadOnly);
    itmDelete.Enabled := SelText<>''; // 
    itmDelete.Visible := not(ReadOnly);
    itmUndo.Enabled := CanUndo; // Undo
    itmUndo.Visible := not(ReadOnly);
  end;
end;

procedure TfrmScriptShow.mScriptShowKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin //  
  if Key=VK_F1 then //    F1
    with (Sender as TSynMemo) do
      if (WordAtCursor='') or (CaretX>Length(LineText)) then Application.HelpJump('StandFunc')
      else Application.HelpJump(WordAtCursor);
  if Key=VK_ESCAPE then // Esc
    ModalResult := mrCancel;
end;

procedure TfrmScriptShow.tlbtnCompareClick(Sender: TObject);
begin //  ,    
  frmMain.PostScriptToCompare(mScriptShow);
end;

procedure TfrmScriptShow.tlbtnRestoreOldClick(Sender: TObject);
begin //  ,   
  CreateScriptForShow;
end;

procedure TfrmScriptShow.CopyNLines(var ASource, ADest: TSynMemo; const BegLine, ACount: Integer{; const Flag: Boolean});
var i: Integer;
begin //    ADest, ACount   ASource   BegLine
  for i:=0 to ACount-1 do
  begin
    ADest.Lines.Add(ASource.Lines[BegLine+i]);
    if ADest = mLocal then
    begin
      SetLength(SS, mLocal.Lines.Count);
      SS[ADest.Lines.Count-1] := BegLine+i+1;
    end;
  end;
end;

procedure TfrmScriptShow.AddNCR(var AMemo: TSynMemo; ACount: Integer{; const Flag: Boolean});
var Tmp: Integer;
begin //    AMemo, ACount  
  Tmp := SS[AMemo.Lines.Count-1];
  while ACount>0 do
  begin
    AMemo.Lines.Add('');
    Dec(ACount);
    if AMemo = mLocal then
    begin
      SetLength(SS, mLocal.Lines.Count);
      SS[AMemo.Lines.Count-1] := Tmp;
    end;
  end;
end;

procedure TfrmScriptShow.CompareTwoTexts(var OneSource, TwoSource, OneDest, TwoDest: TSynMemo);
var
  i, j, i1, j1: Integer;
  FlagL, FlagR: Boolean;
begin //      ,  
  //SetLength(SS, mLocal.Lines.Count+1);
  i := 0; j := 0;
  while (i<OneSource.Lines.Count) or (j<TwoSource.Lines.Count) do
  begin
    if OneSource.Lines[i]=TwoSource.Lines[j] then
    begin //   
      OneDest.Lines.Add(OneSource.Lines[i]);
      TwoDest.Lines.Add(OneSource.Lines[i]);
      Inc(i); Inc(j);
      SetLength(SS, mLocal.Lines.Count);
      SS[mLocal.Lines.Count-1] := i;
    end
    else //    
    begin
      i1 := 0; j1 := 0;
      repeat
        if (i+i1>OneSource.Lines.Count) and (j+j1>TwoSource.Lines.Count) then Break;
        Inc(i1); Inc(j1);
      until ((OneSource.Lines[i]=TwoSource.Lines[j+j1]) and (OneSource.Lines[i]<>'')) or
            ((OneSource.Lines[i+i1]=TwoSource.Lines[j]) and (TwoSource.Lines[j]<>''));
      FlagL := (OneSource.Lines[i]=TwoSource.Lines[j+j1]) and (OneSource.Lines[i]<>'');
      FlagR := (OneSource.Lines[i+i1]=TwoSource.Lines[j]) and (TwoSource.Lines[j]<>'');
      if not(FlagR) and not(FlagL) then
      begin
        OneDest.Lines.Add(OneSource.Lines[i]);
        TwoDest.Lines.Add(TwoSource.Lines[j]);
        Inc(i); Inc(j);
        SetLength(SS, mLocal.Lines.Count);
        SS[mLocal.Lines.Count-1] := i;
      end;
      if FlagL then
      begin
        AddNCR(OneDest, j1);
        OneDest.Lines.Add(OneSource.Lines[i]);
        CopyNLines(TwoSource, TwoDest, j, j1+1);
        Inc(i);
        Inc(j, j1+1);
        SetLength(SS, mLocal.Lines.Count);
        SS[mLocal.Lines.Count-1] := i;
      end
      else if FlagR then
           begin
             AddNCR(TwoDest, j1);
             TwoDest.Lines.Add(TwoSource.Lines[j]);
             CopyNLines(OneSource, OneDest, i, i1+1);
             Inc(j);
             Inc(i, i1+1);
             SetLength(SS, mLocal.Lines.Count);
             SS[mLocal.Lines.Count-1] := i;
           end;
    end;
  end;
end;

procedure TfrmScriptShow.SetCompareScripts;
var i: Integer;
begin //    
  ANameCompare := frmMain.rcdtTemp.Lines[0];
  frmMain.rcdtTemp.Lines.Delete(0);
  mLocal.Lines.Clear;
  mReceived.Lines.Clear;
  mScriptShow.Visible := False;
  tlbrScriptShow.Visible := False;
  tlbrCompare.Visible := True;
  mLocal.Visible := True;
  spltrLoRe.Visible := True;
  mReceived.Visible := True;
  stsbrCompare.Panels[0].Width := mLocal.Width;
  stsbrCompare.Panels[0].Text := AFileName;
  stsbrCompare.Panels.Add; //     
  stsbrCompare.Panels[1].Text := ANameCompare;
  CompareTwoTexts(mScriptShow, frmMain.rcdtTemp, mLocal, mReceived);
  //     
  SetLength(LineCompareL, mLocal.Lines.Count+1);  //      mLocal
  SetLength(LineCompareR, mReceived.Lines.Count+1);  //      mReceived
  for i:=0 to Length(LineCompareL)-1 do
  begin
    if mLocal.Lines[i]=mReceived.Lines[i] then
    begin
      LineCompareL[i] := 0;
      LineCompareR[i] := 0;
    end
    else
    begin
      if (mLocal.Lines[i]='') and (mReceived.Lines[i]<>'') then
      begin
        LineCompareL[i] := 0;
        LineCompareR[i] := 2;
      end;
      if (mLocal.Lines[i]<>'') and (mReceived.Lines[i]='') then
      begin
        LineCompareL[i] := 2;
        LineCompareR[i] := 0;
      end;
      if (mLocal.Lines[i]<>'') and (mReceived.Lines[i]<>'') then
      begin
        LineCompareL[i] := 1;
        LineCompareR[i] := 1;
      end;
    end;
  end;
  ExeCompareL := True;
  ExeCompareR := True;
  //    
  OldColor := LineCompareL[mLocal.CaretY-1];
  OldCaretPosY := mLocal.CaretY;
  LineCompareL[mLocal.CaretY-1] := 3;
  //mLocal.Refresh;
  FlagStart := True;
end;

procedure TfrmScriptShow.mLocalStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
var wP: LongRec;
begin //     
  //     mLocal     mReceived
  if not(FlagScroll) then
  begin
    FlagScroll := True;
    LongRec(wP).Lo := SB_THUMBPOSITION;
    LongRec(wP).Hi := GetScrollPos(mLocal.Handle, SB_VERT);
    SendMessage(mReceived.Handle, WM_VSCROLL, Integer(wP), 0);
    LongRec(wP).Lo := SB_THUMBPOSITION;
    LongRec(wP).Hi := GetScrollPos(mLocal.Handle, SB_HORZ);
    SendMessage(mReceived.Handle, WM_HSCROLL, Integer(wP), 0);
    FlagScroll := False;
  end;
  //    
  if FlagStart and (mLocal.CaretY<>OldCaretPosY) {and (mLocal.SelText='')} then
  begin
    LineCompareL[OldCaretPosY-1] := OldColor;
    OldColor := LineCompareL[mLocal.CaretY-1];
    LineCompareL[mLocal.CaretY-1] := 3;
    OldCaretPosY := mLocal.CaretY;
    mLocal.Refresh;
  end;
end;

procedure TfrmScriptShow.mReceivedStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
var wP: LongRec;
begin //     mReceived     mLocal
  if not(FlagScroll) then
  begin
    FlagScroll := True;
    LongRec(wP).Lo := SB_THUMBPOSITION;
    LongRec(wP).Hi := GetScrollPos(mReceived.Handle, SB_VERT);
    SendMessage(mLocal.Handle, WM_VSCROLL, Integer(wP), 0);
    LongRec(wP).Lo := SB_THUMBPOSITION;
    LongRec(wP).Hi := GetScrollPos(mReceived.Handle, SB_HORZ);
    SendMessage(mLocal.Handle, WM_HSCROLL, Integer(wP), 0);
    FlagScroll := False;
  end;
end;

procedure TfrmScriptShow.mLocalSpecialLineColors(Sender: TObject;
  Line: Integer; var Special: Boolean; var FG, BG: TColor);
begin  //   (  )
  if ExeCompareL and (Line<Length(LineCompareL)) then
    if LineCompareL[Line-1]<>0 then
    begin
      Special := True;
      case LineCompareL[Line-1] of
        1: BG := $00A89CFF;
        2: BG := $00D8D0FF; //  
        3: BG := $F8B058;
      end;
    end;
    HideCaret(mLocal.Handle); //  
end;

procedure TfrmScriptShow.mReceivedSpecialLineColors(Sender: TObject;
  Line: Integer; var Special: Boolean; var FG, BG: TColor);
begin  //   (  )
  if ExeCompareR and (Line<Length(LineCompareR)) then
    if LineCompareR[Line-1]<>0 then
    begin
      Special := True;
      case LineCompareR[Line-1] of
        1: BG := $00A89CFF;
        2: BG := $00D8D0FF; //  
      end;
    end;
    HideCaret(mReceived.Handle); //  
end;

procedure TfrmScriptShow.tlbtnCompareEndClick(Sender: TObject);
begin //   
  mScriptShow.CaretY :=SS[mLocal.CaretY-1];
  SetLength(SS, 0);
  ExeCompareL := False;
  ExeCompareR := False;
  mReceived.Visible := False;
  spltrLoRe.Visible := False;
  mLocal.Visible := False;
  tlbrCompare.Visible := False;
  tlbrScriptShow.Visible := True;
  mScriptShow.Visible := True;
  mLocal.Lines.Clear;
  mReceived.Lines.Clear;
  stsbrCompare.Panels.Delete(1);
  mScriptShow.SetFocus;
end;

procedure TfrmScriptShow.tlbrCompareResize(Sender: TObject);
begin //      
  mLocal.Width := tlbrCompare.Width div 2; //    
  stsbrCompare.Panels[0].Width := mLocal.Width;
end;

procedure TfrmScriptShow.spltrLoReMoved(Sender: TObject);
begin //   
  stsbrCompare.Panels[0].Width := mLocal.Width;
end;

procedure TfrmScriptShow.itmCopyOnlyLClick(Sender: TObject);
begin //   mLocal
  mLocal.CopyToClipboard;
end;

procedure TfrmScriptShow.mnuPopCopyLPopup(Sender: TObject);
begin //    mLocal
  itmCopyOnlyL.Enabled := mLocal.SelText<>''; //   ""
end;

procedure TfrmScriptShow.itmCopyOnlyRClick(Sender: TObject);
begin //   mReceived
  mReceived.CopyToClipboard;
end;

procedure TfrmScriptShow.mnuPopCopyRPopup(Sender: TObject);
begin //    mReceived
  itmCopyOnlyR.Enabled := mReceived.SelText<>''; //   ""
end;

procedure TfrmScriptShow.mLocalDblClick(Sender: TObject);
begin //         
  tlbtnCompareEndClick(Sender);
end;

procedure TfrmScriptShow.tlbtnDownClick(Sender: TObject);
var i: Integer;
begin //    
  i := mLocal.CaretY;
  while (LineCompareL[i]=0) and (LineCompareR[i]=0) and (i<mLocal.Lines.Count) do Inc(i);
  if i<mLocal.Lines.Count then mLocal.CaretY := i+1;
end;

procedure TfrmScriptShow.tlbtnUpClick(Sender: TObject);
var i: Integer;
begin //    
  i := mLocal.CaretY-2;
  while (LineCompareL[i]=0) and (LineCompareR[i]=0) and (i>=0) do Dec(i);
  if i>=0 then mLocal.CaretY := i+1;
end;

procedure TfrmScriptShow.mLocalMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //     mLocal
  HideCaret(mLocal.Handle); //  
end;

procedure TfrmScriptShow.mReceivedMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin //     mReceived
  HideCaret(mReceived.Handle); //  
end;

procedure TfrmScriptShow.mReceivedKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin //     mReceived
  mLocal.SetFocus;
  HideCaret(mLocal.Handle); //  
  PostMessage(mLocal.Handle, WM_KEYDOWN, Key, 0); //    mLocal
end;

procedure TfrmScriptShow.mScriptShowClick(Sender: TObject);
var
  ATempStr: string;
  APosB, APosE: Integer;
  //ANumMSG: Integer;
begin
{  with frmMain do
    if mScriptShow.SelText='' then
    begin
      ATempStr := SearchInData(mScriptShow.WordAtCursor);
      if ATempStr='' then ATempStr := SearchInData(mScriptShow.WordAtCursor);
      stsbrCompare.Panels[0].Text := ATempStr;
    end;  }
  stsbrCompare.Panels[0].Text := '';
  //with frmMain, mScriptShow do //      (grdStandProc)
  with frmMain, Sender as TSynMemo do //      (grdStandProc)
    if SelText='' then
    begin
      {for i:=1 to pnlMain.ControlCount-1 do
        if AnsiLowerCase(lstbxProcNav.Items[i])=AnsiLowerCase(WordAtCursor) then
          tlbtnGoProc.Enabled := True; }
      ATempStr := SearchDescription(grdStandProc, WordAtCursor);
      if ATempStr<>'' then stsbrCompare.Panels[0].Text := ATempStr
      else //    
      begin //   
        if PosFigured(LineText, CaretX, APosB, APosE)<>'' then
        begin //     
          // SelStart  SelEnd  TSynEdit    ,
          //      ,   TMemo  TRichEdit
          SelStart := SelStart - (CaretX - APosB);
          SelEnd := SelStart + (APose - APosB);
        end
        else
        begin //   
          ATempStr := SearchInData(WordAtCursor);
          if ATempStr<>'' then stsbrCompare.Panels[0].Text := ATempStr;
          {else
          begin //   msg-
            ANumMSG := FindNumMsgInString(LineText, WordAtCursor);
            if ANumMSG<>0 then SendToEditMSG(ANumMSG, edtForMSG.Handle); //    
          end; } //    , .     
        end;
      end;
    end;
end;

procedure TfrmScriptShow.mScriptShowKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  AFuncParam: String;
  i, APosB, APosE, ACur: Integer;
begin //   
  if (ssCtrl in Shift) and (Key=57) then // Ctrl+'('
  begin //      
    ACur := mScriptShow.CaretX;
    with mScriptShow do
      for i:=0 to Length(KeyWords)-1 do
        //if grdFunc.Cells[1, i]=WordAtCursor then
        if KeyWords[i].Name=WordAtCursor then
        begin
          AFuncParam := KeyWords[i].Snip;
          APosB := Pos('(', AFuncParam);
          APosE := Pos(')', AFuncParam);
          if (APosB=0) or (APosE=0) then Break;
          mScriptShow.SelText := Copy(AFuncParam, APosB, APosE-APosB+1);
          mScriptShow.CaretX := ACur + 2;
          Break;
        end;
  end;
  mScriptShowClick(Sender);
end;

procedure TfrmScriptShow.tmrScriptShowActivateTimer(Sender: TObject);
begin
  if not frmScriptShow.Active then //frmScriptShow.BringToFront;
    SetForeGroundWindow(frmScriptShow.Handle); //     ,  
end;

procedure TfrmScriptShow.tlbtnViewClick(Sender: TObject);
begin
  mScriptView.Visible := tlbtnView.Down;
  spltrSV.Top := 50;
  spltrSV.Visible := tlbtnView.Down;
  tlbtnViewReRead.Visible := tlbtnView.Down;
end;

procedure TfrmScriptShow.tlbtnViewReReadClick(Sender: TObject);
begin
  mScriptView.Lines := mScriptShow.Lines;
end;

procedure TfrmScriptShow.itmCopyVClick(Sender: TObject);
begin // 
  mScriptView.CopyToClipboard;
end;

procedure TfrmScriptShow.mnuPopVPopup(Sender: TObject);
begin //     Copy
  itmCopyV.Enabled := mScriptView.SelText<>''; // 
end;

end.
