unit untDecompile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ShellAPI, SynEdit, SynMemo, ExtCtrls, ComCtrls, Clipbrd;

type
  TfrmDecompile = class(TForm)
    edtDecompiler: TEdit;
    lblDecompiler: TLabel;
    btnDecompiler: TButton;
    opndlgDecompiler: TOpenDialog;
    edtDecompileDir: TEdit;
    lblDecompilePath: TLabel;
    btnDecompilePath: TButton;
    lblDecompile: TLabel;
    DrctryLstBxDecompilePath: TDirectoryListBox;
    FlstBxDecompileFile: TFileListBox;
    btnDecompileOpen: TButton;
    btnCancel: TButton;
    DriveComboBox1: TDriveComboBox;
    RdBtnDecompile: TRadioButton;
    RdBtnOpen: TRadioButton;
    tmrButtonControl: TTimer;
    edtDecompilerKey: TEdit;
    lblDecompilerKey: TLabel;
    StsBrDecompile: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure btnDecompilerClick(Sender: TObject);
    procedure btnDecompilePathClick(Sender: TObject);
    procedure btnDecompileOpenClick(Sender: TObject);
    procedure FlstBxDecompileFileDblClick(Sender: TObject);
    procedure RdBtnOpenClick(Sender: TObject);
    procedure RdBtnDecompileClick(Sender: TObject);
    procedure tmrButtonControlTimer(Sender: TObject);
    procedure StsBrDecompileDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DriveComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    procedure StartDecompileInt(Sender: TObject);
  public
    { Public declarations }
  end;

function ShowDecompile(AFileInt: string): string;

var
  frmDecompile: TfrmDecompile;
  InFileName, TekDir: string;
  OutFileName: string;
  //HandleDec: HWND;

implementation

uses untMain;

{$R *.DFM}

function ShowDecompile(AFileInt: string): string;
begin
  InFileName := AFileInt;
  with TfrmDecompile.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
  Result := OutFileName;
end;

procedure TfrmDecompile.FormShow(Sender: TObject);
begin //  
  if (PrgOpt.Decompiler<>'') and FileExists(PrgOpt.Decompiler) then
    edtDecompiler.Text := PrgOpt.Decompiler;
  if (PrgOpt.DecompileDir<>'') and DirectoryExists(PrgOpt.DecompileDir) then
    edtDecompileDir.Text := PrgOpt.DecompileDir;
  DrctryLstBxDecompilePath.Directory := ExtractFilePath(InFileName);
  FlstBxDecompileFile.FileName := InFileName; //ExtractFileName(IntFileName);
  edtDecompilerKey.Text := PrgOpt.DecompilerKey;
end;

procedure TfrmDecompile.btnDecompilerClick(Sender: TObject);
begin //  
  if edtDecompiler.Text<>'' then opndlgDecompiler.InitialDir := ExtractFilePath(edtDecompiler.Text)
  else opndlgDecompiler.InitialDir := ExtractFilePath(PrgOpt.Decompiler);
  if opndlgDecompiler.Execute then
  begin
    edtDecompiler.Text := opndlgDecompiler.FileName;
    PrgOpt.Decompiler := edtDecompiler.Text;
    opndlgDecompiler.FileName := '';
  end;
end;

procedure TfrmDecompile.btnDecompilePathClick(Sender: TObject);
begin //     
  if SelectDirectory('    :', '', PrgOpt.DecompileDir) then
    edtDecompileDir.Text := PrgOpt.DecompileDir;
end;

procedure TfrmDecompile.btnDecompileOpenClick(Sender: TObject);
begin //   
  if RdBtnDecompile.Checked then StartDecompileInt(Sender)
  else
  begin
    OutFileName := FlstBxDecompileFile.FileName;
    Close;
  end;
end;

procedure TfrmDecompile.StartDecompileInt(Sender: TObject);
var APress: Integer;
begin // 
  with FlstBxDecompileFile do
    if FileName<>'' then
    begin
      if (edtDecompiler.Text='') or not(FileExists(edtDecompiler.Text)) then
      begin
        //ShowMessage('  ');
        edtDecompiler.Text := '';
        MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
          PChar('  .'),
          PChar(' int-'),
          MB_ICONERROR + MB_OK);
        Exit;
      end;
      if (edtDecompileDir.Text='') or not(DirectoryExists(edtDecompileDir.Text)) then
      begin
        edtDecompileDir.Text := '';
        MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
          PChar('   .'),
          PChar(' int-'),
          MB_ICONERROR + MB_OK);
        Exit;
      end;
      //ShowMessage(FileName);
      APress := IDYES;
      OutFileName := IncludeTrailingBackslash(edtDecompileDir.Text) +
                     ChangeFileExt(ExtractFileName(FileName), '.ssl');
      if FileExists(OutFileName) then
      begin
        APress := MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
          PChar('   "' +
                IncludeTrailingBackslash(edtDecompileDir.Text) + '"' + //CR +
                '    "' +
                ChangeFileExt(ExtractFileName(FileName),'.ssl') + '".' + CR + CR +
                ' ?'),
          PChar(' int-'),
          MB_ICONWARNING + MB_YESNO);
      end;
      if APress=IDYES then
      begin
        ShellExecute(Application.Handle,
                     'open',
                     PChar(edtDecompiler.Text),
                     PChar(' ' + edtDecompilerKey.Text + ' '+ FileName + ' ' +
                     OutFileName),
                     nil,
                     SW_SHOWNORMAL);
        //Timer1.Enabled := True;
      end;
    end
    else MessageBox(GetForegroundWindow, //     GetForegroundWindow  Self.Handle
                    PChar('  int-  .'),
                    PChar(' int-'),
                    MB_ICONERROR + MB_OK);
  OutFileName := '';
end;

procedure TfrmDecompile.FlstBxDecompileFileDblClick(Sender: TObject);
begin
  with FlstBxDecompileFile do
    if FileName<>'' then btnDecompileOpenClick(Sender);
end;

procedure TfrmDecompile.RdBtnOpenClick(Sender: TObject);
begin //    
  StsBrDecompile.Panels[0].Text := '';
  TekDir := FlstBxDecompileFile.Directory;
  btnDecompileOpen.Caption := '';
  lblDecompile.Caption := ' ssl-,     :';
  if DirectoryExists(edtDecompileDir.Text) then
    FlstBxDecompileFile.Directory := edtDecompileDir.Text;
  FlstBxDecompileFile.Mask := '*.ssl';
end;

procedure TfrmDecompile.RdBtnDecompileClick(Sender: TObject);
begin //   ""
  StsBrDecompile.Panels[0].Text := '';
  btnDecompileOpen.Caption := '';
  lblDecompile.Caption := ' int-  :';
  if DirectoryExists(ExtractFilePath(TekDir)) then
    FlstBxDecompileFile.Directory := TekDir;
  FlstBxDecompileFile.Mask := '*.int';
end;

procedure TfrmDecompile.tmrButtonControlTimer(Sender: TObject);
begin //   ""
  with FlstBxDecompileFile do
  begin
    btnDecompileOpen.Enabled := (FileName<>'');
    if RdBtnDecompile.Checked then // 
    begin
      if FileName<>'' then
        StsBrDecompile.Panels[0].Text := edtDecompiler.Text + ' ' +
          edtDecompilerKey.Text + ' '+ FileName + ' ' +
          IncludeTrailingBackslash(edtDecompileDir.Text) +
          ChangeFileExt(ExtractFileName(FileName), '.ssl');
        StsBrDecompile.Hint := StsBrDecompile.Panels[0].Text;
    end
    else
    begin
      StsBrDecompile.Panels[0].Text := FileName;
      StsBrDecompile.Hint := StsBrDecompile.Panels[0].Text;
    end;
  end;
end;

procedure TfrmDecompile.StsBrDecompileDblClick(Sender: TObject);
begin //     
  Clipboard.AsText := StsBrDecompile.Panels[0].Text;
end;

procedure TfrmDecompile.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (edtDecompiler.Text<>'') and FileExists(edtDecompiler.Text) then
    PrgOpt.Decompiler := edtDecompiler.Text;
  if (edtDecompileDir.Text<>'') and DirectoryExists(edtDecompileDir.Text) then
    PrgOpt.DecompileDir := edtDecompileDir.Text;
  PrgOpt.DecompilerKey := edtDecompilerKey.Text;
end;

procedure TfrmDecompile.DriveComboBox1Change(Sender: TObject);
begin
  //        ,
  //       - CD-
  DrctryLstBxDecompilePath.SetFocus;
end;

end.
